% ============ main_tone_corr.m ===========
%      
% x -  () 
% Ton -     (0 -  )
% ====================================
k = 1;
%  
fs = 11025; nfft = 512*k; numoverlap = nfft/2; %  .  nfft/2
step=nfft-numoverlap; %  
window = rectwin(nfft);   
%
tic   %  
% =======  2-   =====
sig2dim=[];
for ik = 1:step:(length(x)-nfft)    %   
    for jk = 1:nfft
        seg_sig2dim(jk) = x(jk+ik-1).*window(jk);
    end;
    seg_sig2dim = seg_sig2dim-mean(seg_sig2dim);
    sig2dim=[sig2dim seg_sig2dim'];
end;

% ====   ====
sig_clip=[];     %  
for ic = 1:size(sig2dim,2)
    seg_sig = sig2dim(:,ic);    %   
    seg_sig = seg_sig/max(abs(seg_sig));  %    
    % seg_clip -   
    for jc = 1:length(seg_sig)
        if seg_sig(jc)> 0.75
            seg_clip(jc)=seg_sig(jc)-0.75;
        elseif seg_sig(jc)< -0.75
            seg_clip(jc)=seg_sig(jc)+0.75;
        else
            seg_clip(jc)=0;
        end
    end
    sig_clip=[sig_clip seg_clip']; % sig_clip -   
end

% ======     ========
akf_clip=[];  %   
for ic = 1:size(sig2dim,2)
    [akf_seg_clip,tau_clip]=xcov(sig_clip(:,ic),'coeff');
    akf_clip=[akf_clip akf_seg_clip];
end

% ======     ========
akf_inf=akf_clip(nfft+20:nfft+130,:);       %    
[akf_infm,indmx]=max(akf_inf);
for ic=1:length(akf_infm)
    if akf_infm(ic)<0.35
        Ton(ic)=0;
    else
        Ton(ic)=fs/(indmx(ic)+19);
    end
end
toc   %  

% ===        ===
t = 0:1/fs:(length(x)-1)/fs;   %     
tTon=0:step/fs:(length(x)-nfft)/fs;  
figure;
s(1) = subplot(2,1,1); % top subplot
s(2) = subplot(2,1,2); % bottom subplot
plot(s(1),t,x); grid on;
title(s(1),'')
xlabel(s(1),', '); ylabel(s(1),'г')
plot(s(2),tTon,Ton);  grid on;   %    
title(s(2),'   (.)')
xlabel(s(2),', '); ylabel(s(2),', ')